const wxBugDegSym = '\u00B0';
var wxBugEnglishUnits = wxBugDegSym + 'F';
var wxBugMetricUnits = wxBugDegSym + 'C';

function wxBugGetUnitsDisplay() {
	if (wxBugGetCharPref(wxBugPrefUnits, '0') == '0')
		return wxBugEnglishUnits;
	else
		return wxBugMetricUnits;
}

function wxBugIsUs() {
	if (wxBugGetCharPref(wxBugPrefZipCode, '-1') != '-1')
		return true;
	else {
		if (wxBugGetCharPref(wxBugPrefCityCode, '-1') != '-1')
			return false;
		else
			return true;
	}
}

function wxBugUserHasLocation() {
	return ((wxBugGetCharPref(wxBugPrefZipCode, '-1') != '-1') || (wxBugGetCharPref(wxBugPrefCityCode, '-1') != '-1'))
	    && (wxBugGetCharPref(wxBugPrefStationId, '-1') != '-1');
}

function wxBugResetLastUpdate() {
	wxBugSetCharPref(wxBugPrefAlertLastUpdate, '0');
	wxBugSetCharPref(wxBugPrefForecastLastUpdate, '0');
	wxBugSetCharPref(wxBugPrefObsLastUpdate, '0');
}

function wxBugResetUi() {
	var temperBtn = document.getElementById('wxBugTemperature');
	temperBtn.setAttribute('class', 'wxBugTemperature');
	temperBtn.setAttribute('value', '--');
	var foreNum = 0;
	var foreElement = document.getElementById('wxBugForePer' + foreNum);
	while (foreElement) {
		foreElement.image = '';
		foreElement.label = '-';
		document.getElementById('wxBugForePer' + foreNum).src = '';
		document.getElementById('wxBugForePerTipImg' + foreNum).src = '';
		document.getElementById('wxBugForePerTipPer' + foreNum).value = '';
		document.getElementById('wxBugForePerTipHiLo' + foreNum).value = '';
		foreNum++;
		foreElement = document.getElementById('wxBugForePer' + foreNum);
	}
}
			
//Logging
const wxBugConsoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);

function wxBugLog(msg) {
    if (wxBugGetBoolPref(wxBugPrefLoggingEnabled, false)) {
		var now = new Date();
		wxBugConsoleService.logStringMessage('WeatherBug - ' + now.toLocaleString() + ' - : ' + msg);
	}
	
}

function wxBugGetBrowserWin()
{
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var top = wm.getMostRecentWindow("navigator:browser");
    
    if (!top) 
    {
       var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
       top = ww.openWindow(null, "chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank");
    }
    
    return top;  
}


const StatusBarId = 'status-bar';
var DefaultPosition = StatusBarId;
const WxBugToolbarId = 'wxBugToolbar';
const WxBugContentId = 'wxBugBox';
const WxBugContainerId = 'wxBugContainer'

function wxBugSetPlacement()
{
    //get desired position
    var position = wxBugGetCharPref(wxBugPrefPlacement, '-1');
    if ('-1' == position)
    {
        position = DefaultPosition;
        wxBugSetCharPref(wxBugPrefPlacement, position)
    }
    
    //get the browser dom
    win = wxBugGetBrowserWin();
    
    //get WeatherBug box
    var bugContent = win.document.getElementById(WxBugContentId);
    var bugToolbar = win.document.getElementById(WxBugToolbarId);
    
    //get desired location node
    var placementNode = win.document.getElementById(position);
    
    //wxBugLog('position: ' + position);
    //wxBugLog('bugContent.parentNode.id: ' + bugContent.parentNode.id);
    //wxBugLog('position == bugContent.parentNode.id: ' + (position == bugContent.parentNode.id));
    
    // if none set or in already in right position, do nothing
    if (position == '-1' || position == bugContent.parentNode.id)
        return;
    
    //remove existing placement
    bugContent.parentNode.removeChild(bugContent);
    
    //if in toolbar make toolbar visible
    if (WxBugToolbarId == position) 
        bugToolbar.setAttribute('hidden', 'false');
    else
        bugToolbar.setAttribute('hidden', 'true');
    
    //create the appropriate container
    var container = null;
    if (StatusBarId == position)
        container = document.createElement('statusbarpanel');
    else if (WxBugToolbarId == position) 
        container = bugToolbar;
    
    // if we had to create container append our box to the new element
    if (container)
        bugContent = container.appendChild(bugContent);
        
    //place our content
    placementNode.appendChild(bugContent);
}

// Tokens
const wxBugZipCodeToken = '^^ZipCode^^';
const wxBugUnitsToken = '^^Units^^';
const wxBugUserIdToken = '^^Uid^^';
const wxBugCityCodeToken = '^^CityCode^^';
const wxBugStationIdToken = '^^StatId^^';
const wxBugZCodeToken = '^^ZCode^^';
const wxBugAppNameToken = '^^AppName^^';
const wxBugAppVersionToken = '^^AppVersion^^';

function wxBugDeTokenizeUrl (url) {
	var deUrl = wxBugReplace(url, wxBugZipCodeToken, wxBugGetCharPref(wxBugPrefZipCode, '-1'));
	deUrl = wxBugReplace(deUrl, wxBugUnitsToken, wxBugGetCharPref(wxBugPrefUnits, '1'));
	deUrl = wxBugReplace(deUrl, wxBugCityCodeToken, wxBugGetCharPref(wxBugPrefCityCode, '-1'));
	deUrl = wxBugReplace(deUrl, wxBugUserIdToken, wxBugGetCharPref(wxBugPrefUserId, 'na'));	
	deUrl = wxBugReplace(deUrl, wxBugStationIdToken, wxBugGetCharPref(wxBugPrefStationId, 'na'));	
	deUrl = wxBugReplace(deUrl, wxBugZCodeToken, wxBugZCode);	
	deUrl = wxBugReplace(deUrl, wxBugAppVersionToken, wxBugAppVersion);	
	deUrl = wxBugReplace(deUrl, wxBugAppNameToken, wxBugAppName);	
	
	return deUrl;
}


// Utils
function wxBugReplace(expression, find, replaceWith) {
	var len = find.length;
	var pos = 0;
	pos = expression.indexOf(find);
	var preString = '';
	var postString = '';
	while (pos != -1) {
		preString = expression.substring(0, pos);
		postString = expression.substring((pos + len), expression.length);
		expression = preString + replaceWith + postString;
		pos = expression.indexOf(find);		
	}
	
	return expression;
}

function wxBugGetInt(expr, defaultVal) {
	var intExpr;
	try {
		intExpr = parseInt(expr);
	}
	catch(e) {
		intExpr = defaultVal;
	}
	
	return intExpr;
}

function wxBugIsNumeric(expr) {
	var regExpr = /(^-{0,1}\d*\.{0,1}\d+$)/;
	return regExpr.test(expr);
}

function wxBugIsDataExpired(lastUpdate, interval) {
	var now = new Date();
	return ((now.getTime() - lastUpdate) >= interval);
}